
USE [AdventureWorks]
go

CREATE QUEUE receiveq
go
-- default means receiver can receive any type of message
CREATE SERVICE receiver
	ON QUEUE receiveq
	([DEFAULT])
go

-- RECEIVER CREATED

CREATE QUEUE senderq 
go

-- no contract means sender cannot receive any user messages
CREATE SERVICE sender
	ON QUEUE senderq
go

-- SENDER CREATED

DECLARE @h UNIQUEIDENTIFIER;
BEGIN TRY
	BEGIN DIALOG CONVERSATION @h
	FROM SERVICE sender
	TO SERVICE 'receiver'
	WITH ENCRYPTION = OFF;

	SEND ON CONVERSATION @h
	('Hello World');
END TRY
BEGIN CATCH
	PRINT ERROR_MESSAGE()
END CATCH
END CONVERSATION @h;
go

-- MESSAGE SENT

DECLARE @h UNIQUEIDENTIFIER;
DECLARE @m VARCHAR(MAX);
RECEIVE TOP(1) @h=conversation_handle, 
		@m=CAST(message_body as VARCHAR(MAX)) FROM receiveq;
PRINT @m;
END CONVERSATION @h;
go

-- MESSAGE RECEIVED







